/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.Marshal
 *  com.locojoy.base.Marshal.OctetsStream
 *  fire.pb.PropConf$Sys
 *  fire.pb.SSendQueueInfo
 *  fire.pb.main.ConfigManager
 *  fire.pb.main.JumpQueueUser
 *  fire.pb.main.LoginQueueUp
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 */
package gnet.link;

import com.locojoy.base.Marshal.Marshal;
import com.locojoy.base.Marshal.OctetsStream;
import fire.pb.PropConf;
import fire.pb.SSendQueueInfo;
import fire.pb.main.ConfigManager;
import fire.pb.main.JumpQueueUser;
import fire.pb.main.LoginQueueUp;
import gnet.link.Dispatch;
import gnet.link.Link;
import gnet.link.Onlines;
import gnet.link.QueueUpQueue;
import gnet.link.Send;
import gnet.link.User;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import mkio.Protocol;
import org.apache.log4j.Logger;

public class ConnectedUsers
extends HashMap<Integer, User> {
    static Map<Integer, LoginQueueUp> loginQueueUpMap = ConfigManager.getInstance().getConf(LoginQueueUp.class);
    private static int broadcastQueuePeriod = 20000;
    private static final Logger LOG = Logger.getLogger((String)"SYSTEM");
    private static final long serialVersionUID = -2032473210881256513L;
    public int healthConnectedUserNumber = 1;
    public int queueUpNumber = 1;
    public int maxConnectedUserNumber = 10;
    private QueueUpQueue normalQueue = new QueueUpQueue(User.STATE_IN_QUEUE);
    private QueueUpQueue priorQueue = new QueueUpQueue(User.STATE_ZERO_QUEUE);
    private QueueUpQueue slowQueue = new QueueUpQueue(User.STATE_SLOW_QUEUE);
    private Map<Integer, Long> priorQueueTickets = new HashMap<Integer, Long>();
    private volatile long lastSequenceWaitTime = 0L;
    int maxQueueSize = 0;
    private static int zeroQueueTicketTime = 120000;
    public int avgLoginSpeed = 3;
    private int curLoginNum = 0;
    private long lastBroadcastTime = 0L;
    private List<Integer> latelyThreeCountSpeeds = new LinkedList<Integer>();
    private Collection<LoginQueueUp> loginQueueUpLst = null;

    public ConnectedUsers() {
        this.initialization();
    }

    private void initialization() {
        int confSize = loginQueueUpMap.size();
        LoginQueueUp queueUpNumberConf = loginQueueUpMap.get(confSize);
        LoginQueueUp healthConnectedUserNumberConf = loginQueueUpMap.get(1);
        if (queueUpNumberConf == null || healthConnectedUserNumberConf == null) {
            LOG.error((Object)"f服务器登录排队配置错误!");
            System.exit(-1);
            return;
        }
        this.loginQueueUpLst = loginQueueUpMap.values();
        this.healthConnectedUserNumber = healthConnectedUserNumberConf.connectusernum;
        this.queueUpNumber = queueUpNumberConf.connectusernum;
        this.maxConnectedUserNumber = PropConf.Sys.MAX_CONNECTED_NUMBER;
        zeroQueueTicketTime = PropConf.Sys.ZERO_QUEUE_TICKET_TIME;
        broadcastQueuePeriod = PropConf.Sys.BROADCAST_QUEUE_PERIOD;
        this.maxQueueSize = this.maxConnectedUserNumber - this.queueUpNumber;
    }

    synchronized void broadcastQueueInfo(long now) {
        long period = now - this.lastBroadcastTime;
        if (period < (long)broadcastQueuePeriod) {
            return;
        }
        this.lastBroadcastTime = now;
        int sidex = 0;
        for (User user : this.slowQueue.values()) {
            user.setSlowQueueIndex(++sidex);
            this.slowQueue.transferQueueInformation(user);
        }
        int size = this.normalQueue.size();
        if (this.priorQueue.size() > 0) {
            SSendQueueInfo snd = new SSendQueueInfo(0, size, 0);
            this.send(this.priorQueue.values(), (Protocol)snd);
        }
        this.avgLoginSpeed = this.calcAvgLoginSpeed(period);
        int i = 0;
        for (User user : this.normalQueue.values()) {
            SSendQueueInfo snd = new SSendQueueInfo(++i, size, (i / this.avgLoginSpeed + 1) * 60);
            user.send((Protocol)snd);
        }
        ArrayList<Integer> timeoutTickets = new ArrayList<Integer>();
        for (Map.Entry<Integer, Long> entry : this.priorQueueTickets.entrySet()) {
            if (now - entry.getValue() <= (long)zeroQueueTicketTime) continue;
            timeoutTickets.add(entry.getKey());
        }
        Iterator<Map.Entry<Integer, Long>> iterator = timeoutTickets.iterator();
        while (iterator.hasNext()) {
            int userid = (Integer)((Object)iterator.next());
            this.priorQueueTickets.remove(userid);
        }
    }

    private int calcAvgLoginSpeed(long period) {
        int curspeed = (int)((long)this.curLoginNum * (60000L / period));
        this.latelyThreeCountSpeeds.add(curspeed);
        int totalSpeed = 0;
        for (int speed : this.latelyThreeCountSpeeds) {
            totalSpeed += speed;
        }
        int avgSpeed = totalSpeed / this.latelyThreeCountSpeeds.size();
        if (this.latelyThreeCountSpeeds.size() >= 3) {
            this.latelyThreeCountSpeeds.remove(0);
        }
        this.curLoginNum = 0;
        return Math.max(3, avgSpeed);
    }

    public User getUserByUserId(int userid) {
        User user = this.get(userid);
        if (user != null) {
            return user;
        }
        user = (User)this.priorQueue.get(userid);
        if (user != null) {
            return user;
        }
        user = (User)this.normalQueue.get(userid);
        if (user != null) {
            return user;
        }
        return null;
    }

    @Override
    public synchronized User get(Object key) {
        return (User)super.get(key);
    }

    public User getUserFromQueue() {
        User user = this.getUserFromQueue(this.priorQueue);
        if (user != null) {
            return user;
        }
        return this.getUserFromQueue(this.normalQueue);
    }

    private User getUserFromQueue(QueueUpQueue queue) {
        if (queue.isEmpty()) {
            return null;
        }
        long now = System.currentTimeMillis();
        Iterator it = queue.values().iterator();
        while (it.hasNext()) {
            User user = (User)it.next();
            it.remove();
            if (!user.isLinkBroken()) {
                this.broadcastQueueInfo(now);
                return user;
            }
            this.priorQueueTickets.put(user.getUserid(), now);
        }
        return null;
    }

    private synchronized int getConnectUserCount() {
        return this.size() + this.slowQueue.size();
    }

    public synchronized int getQueueUpNumber() {
        return this.normalQueue.size() + this.priorQueue.size();
    }

    int getUserQueueSize(int queueUserState) {
        if (queueUserState == User.STATE_IN_QUEUE) {
            return this.normalQueue.size();
        }
        if (queueUserState == User.STATE_ZERO_QUEUE) {
            return this.priorQueue.size();
        }
        return 0;
    }

    public synchronized User offline(int userid, boolean isLinkBroken) {
        User user = this.remove(userid);
        if (user != null) {
            if (isLinkBroken) {
                this.priorQueueTickets.put(userid, System.currentTimeMillis());
            }
            return user;
        }
        user = (User)this.slowQueue.get(userid);
        if (user != null) {
            if (isLinkBroken) {
                user.setLinkBroken(true);
            } else {
                this.slowQueue.remove(userid);
                this.broadcastQueueInfo(System.currentTimeMillis());
            }
            return user;
        }
        user = (User)this.priorQueue.get(userid);
        if (user != null) {
            if (isLinkBroken) {
                user.setLinkBroken(true);
            } else {
                this.priorQueue.remove(userid);
            }
            return user;
        }
        user = (User)this.normalQueue.get(userid);
        if (user != null) {
            if (isLinkBroken) {
                user.setLinkBroken(true);
            } else {
                this.normalQueue.remove(userid);
                this.broadcastQueueInfo(System.currentTimeMillis());
            }
            return user;
        }
        return null;
    }

    private User online(Link link, int linksid, int userId, boolean isGm) {
        LOG.error((Object)new StringBuilder("User登录 UserId = ").append(userId).append(" linksid= ").append(linksid));
        if (null != link) {
            User oldUser = this.get(userId);
            if (oldUser != null) {
                LOG.error((Object)new StringBuilder("如果在线用户列表中存在，直接返回。UserId = ").append(userId));
                this.remove(userId);
            }
            if ((oldUser = this.dealOldUserOnline(oldUser, link, linksid, userId)) != null) {
                return oldUser;
            }
            return this.dealNewUserOnline(link, linksid, userId, isGm);
        }
        LOG.info((Object)"Can't found User Link");
        return null;
    }

    private User dealNewUserOnline(Link link, int linksid, int userid, boolean isAdmin) {
        User user = new User(userid);
        user.linkAttach(link, linksid);
        long now = System.currentTimeMillis();
        if (this.healthConnectedUserNumber > this.size()) {
            this.put(userid, user);
            return user;
        }
        if (ConfigManager.getInstance().getConf(JumpQueueUser.class).containsKey(userid)) {
            this.put(userid, user);
            return user;
        }
        if (isAdmin) {
            this.put(userid, user);
            return user;
        }
        if (this.getConnectUserCount() >= this.healthConnectedUserNumber && this.getConnectUserCount() < this.queueUpNumber) {
            Long time = this.priorQueueTickets.get(userid);
            if (time != null) {
                this.priorQueueTickets.remove(userid);
                if (now - time < (long)zeroQueueTicketTime) {
                    this.put(user.getUserid(), user);
                    return user;
                }
            }
            this.slowQueue.put(userid, this.createSlowUser(user, now));
            this.broadcastQueueInfo(now);
            return user;
        }
        Long time = this.priorQueueTickets.get(userid);
        if (time != null) {
            this.priorQueueTickets.remove(userid);
            if (now - time < (long)zeroQueueTicketTime) {
                this.priorQueue.put(user.getUserid(), user);
                this.broadcastQueueInfo(now);
                return user;
            }
        }
        if (this.getQueueUpNumber() < this.maxQueueSize) {
            this.normalQueue.put(user.getUserid(), user);
            this.broadcastQueueInfo(now);
            return user;
        }
        user.setState(User.STATE_FAILED);
        user.send((Protocol)new SSendQueueInfo(-1, -1, -1));
        return user;
    }

    private User dealOldUserOnline(User oldUser, Link link, int linksid, int userid) {
        QueueUpQueue queue = null;
        long now = System.currentTimeMillis();
        oldUser = (User)this.priorQueue.get(userid);
        queue = this.priorQueue;
        if (null == oldUser) {
            oldUser = (User)this.slowQueue.get(userid);
            queue = this.slowQueue;
            if (null != oldUser && now >= oldUser.getEnterTime()) {
                User user = this.put(userid, oldUser);
                this.slowQueue.remove(userid);
                return oldUser;
            }
        }
        if (null == oldUser) {
            oldUser = (User)this.normalQueue.get(userid);
            queue = this.normalQueue;
        }
        if (null != oldUser) {
            oldUser.setLinkBroken(false);
            oldUser.linkAttach(link, linksid);
            if (queue != null) {
                queue.transferQueueInformation(oldUser);
            }
        }
        return oldUser;
    }

    public synchronized User online(Protocol p2, boolean isGm) {
        Dispatch ctx = (Dispatch)((Object)p2.getContext());
        return this.online(Onlines.getInstance().find(p2.getConnection()), ctx.linksid, ctx.userid, isGm);
    }

    @Override
    public synchronized User put(Integer key, User user) {
        ++this.curLoginNum;
        user.setState(User.STATE_LOGIN);
        user.sendRoleList(false);
        return super.put(key, user);
    }

    private void refreshQueue() {
        User newuser = this.getUserFromQueue();
        if (newuser == null) {
            return;
        }
        this.put(newuser.getUserid(), newuser);
    }

    @Override
    public synchronized User remove(Object key) {
        User olduser = (User)super.remove(key);
        if (olduser == null) {
            return null;
        }
        olduser.setLogin(0);
        this.refreshQueue();
        return olduser;
    }

    public boolean send(Collection<User> users, Protocol protocol) {
        HashMap<Link, HashSet<Integer>> linkGroup = new HashMap<Link, HashSet<Integer>>();
        boolean rc = true;
        for (User user : users) {
            Link.Session ls = user.getLinkSession();
            if (null == ls) {
                rc = false;
                continue;
            }
            HashSet<Integer> si = (HashSet<Integer>)linkGroup.get(ls.getLink());
            if (null == si) {
                si = new HashSet<Integer>();
                linkGroup.put(ls.getLink(), si);
            }
            si.add(ls.getSid());
        }
        Send msg = new Send();
        msg.ptype = protocol.getType();
        msg.pdata = new OctetsStream().marshal((Marshal)protocol);
        for (Map.Entry e : linkGroup.entrySet()) {
            msg.linksids.clear();
            if (Onlines.getInstance().send((Link)e.getKey(), (HashSet<Integer>)((HashSet)e.getValue()), msg)) continue;
            rc = false;
            LOG.warn((Object)("协议发送错误 , Protocol=" + Integer.toHexString(protocol.getType()) + "link=" + e.getKey()));
        }
        return rc;
    }

    private synchronized User createSlowUser(User user, long now) {
        long enterTime = 0L;
        int connectUserNum = this.getConnectUserCount();
        int idx = 0;
        int len = this.loginQueueUpLst.size();
        for (LoginQueueUp lqu : this.loginQueueUpLst) {
            if (idx++ == len) break;
            int connectUserNumConf = lqu.connectusernum;
            int timeConf = lqu.time;
            double enterUserNumConf = lqu.enterusernum;
            if (timeConf <= 0 || enterUserNumConf <= 0.0) continue;
            int waitTime = (int)((double)timeConf / enterUserNumConf * 1000.0);
            if (connectUserNum < connectUserNumConf) continue;
            if (this.lastSequenceWaitTime < now) {
                enterTime = this.lastSequenceWaitTime = now + (long)waitTime;
                break;
            }
            enterTime = this.lastSequenceWaitTime += (long)waitTime;
            break;
        }
        user.setSlowQueueIndex(this.slowQueue.size());
        user.setEnterTime(enterTime);
        return user;
    }
}

